import "antd/es/date-picker/style";
import _DatePicker from "antd/es/date-picker";
import "antd/es/radio/style";
import _Radio from "antd/es/radio";

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _unsupportedIterableToArray(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance.\nIn order to be iterable, non-array objects must have a [Symbol.iterator]() method."); }

function _unsupportedIterableToArray(o, minLen) { if (!o) return; if (typeof o === "string") return _arrayLikeToArray(o, minLen); var n = Object.prototype.toString.call(o).slice(8, -1); if (n === "Object" && o.constructor) n = o.constructor.name; if (n === "Map" || n === "Set") return Array.from(o); if (n === "Arguments" || /^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(n)) return _arrayLikeToArray(o, minLen); }

function _arrayLikeToArray(arr, len) { if (len == null || len > arr.length) len = arr.length; for (var i = 0, arr2 = new Array(len); i < len; i++) { arr2[i] = arr[i]; } return arr2; }

function _iterableToArrayLimit(arr, i) { var _i = arr == null ? null : typeof Symbol !== "undefined" && arr[Symbol.iterator] || arr["@@iterator"]; if (_i == null) return; var _arr = []; var _n = true; var _d = false; var _s, _e; try { for (_i = _i.call(arr); !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

import React, { useRef, useEffect } from 'react';
import moment from 'moment';
import { isNull } from 'lodash-es';
import { useSetState } from 'ahooks';
import { isEmpty } from '@parallel-line/utils';
import './style/index';
var formatMap = {
  time: 'YYYY-MM-DD HH:mm',
  date: 'YYYY-MM-DD'
};

var DatePicker = function DatePicker(props) {
  var switchRef = useRef(false);
  var pCls = "".concat(props.prefixCls, "-date-picker");
  var pClsDropdown = "".concat(pCls, "-dropdown");

  var _useSetState = useSetState({
    type: 'time',
    open: false,
    value: undefined
  }),
      _useSetState2 = _slicedToArray(_useSetState, 2),
      state = _useSetState2[0],
      setState = _useSetState2[1];

  useEffect(function () {
    if (isEmpty(props.value)) return;
    var _moment = props.value;

    if (!moment.isMoment(props.value)) {
      _moment = moment(props.value, 'YYYY-MM-DDTHH:mm:ss');
    }

    var second = _moment.get('second');

    var type = second === 59 ? 'date' : 'time';
    setState({
      value: _moment,
      type: type
    });
  }, [props.value]);

  var handleSwitch = function handleSwitch(e) {
    var value = e.target.value;
    switchRef.current = value === 'time';
    setState({
      type: value
    });
  };

  var renderExtraFooter = function renderExtraFooter() {
    return /*#__PURE__*/React.createElement("div", {
      className: "".concat(pClsDropdown, "-switch")
    }, /*#__PURE__*/React.createElement(_Radio.Group, {
      value: state.type,
      onChange: handleSwitch
    }, /*#__PURE__*/React.createElement(_Radio.Button, {
      value: "time"
    }, "\u65F6\u95F4"), /*#__PURE__*/React.createElement(_Radio.Button, {
      value: "date"
    }, "\u65E5\u671F")));
  };

  var handleChange = function handleChange(value) {
    var _props$onChange3;

    if (isNull(value)) {
      var _props$onChange;

      setState({
        value: undefined
      });
      (_props$onChange = props.onChange) === null || _props$onChange === void 0 ? void 0 : _props$onChange.call(props);
      return;
    }

    var _moment = value.clone();

    if (state.type === 'time') {
      var _props$onChange2;

      _moment.set({
        second: 0
      });

      (_props$onChange2 = props.onChange) === null || _props$onChange2 === void 0 ? void 0 : _props$onChange2.call(props, _moment);
      return;
    }

    _moment.set({
      hour: 23,
      minute: 23,
      second: 59
    });

    (_props$onChange3 = props.onChange) === null || _props$onChange3 === void 0 ? void 0 : _props$onChange3.call(props, _moment);
  };

  var handleOpenChange = function handleOpenChange(open) {
    setTimeout(function () {
      if (switchRef.current && !open) {
        switchRef.current = false;
        return;
      }

      setState({
        open: open
      });
    }, 1);
  };

  return /*#__PURE__*/React.createElement(_DatePicker, {
    className: pCls,
    open: state.open,
    value: state.value,
    style: props.style,
    onChange: handleChange,
    disabled: props.disabled,
    format: formatMap[state.type],
    onOpenChange: handleOpenChange,
    placeholder: props.placeholder,
    showTime: state.type === 'time',
    dropdownClassName: pClsDropdown,
    renderExtraFooter: renderExtraFooter,
    getPopupContainer: props.getPopupContainer
  });
};

DatePicker.defaultProps = {
  prefixCls: 'pxx'
};
export default DatePicker;